unit Frame;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, Menus, Mandelbrot, StdCtrls, ComCtrls, Math, Param, ShellAPI,
  Clipbrd, jpeg, FileCtrl, DropSource, DropBMPSource, Compress;

  var
  CF_JFIF: Word;

type
  TFrameForm = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Edit1: TMenuItem;
    Save1: TMenuItem;
    N1: TMenuItem;
    Exit1: TMenuItem;
    Bitmap1: TMenuItem;
    Help1: TMenuItem;
    SearchforHelpOn1: TMenuItem;
    About1: TMenuItem;
    Panel1: TPanel;
    ScrollBox1: TScrollBox;
    Mandelbrot1: TMandelbrot;
    Button1: TButton;
    Button2: TButton;
    Mandelbrot2: TMandelbrot;
    Button3: TButton;
    Button4: TButton;
    Parameter1: TParameter;
    Button5: TButton;
    Button6: TButton;
    Label1: TLabel;
    Edit2: TEdit;
    Label2: TLabel;
    Label3: TLabel;
    Edit3: TEdit;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Edit4: TEdit;
    Edit5: TEdit;
    Edit6: TEdit;
    SaveDialog1: TSaveDialog;
    Parameter2: TParameter;
    Save2: TMenuItem;
    N2: TMenuItem;
    Open1: TMenuItem;
    OpenDialog1: TOpenDialog;
    SaveDialog2: TSaveDialog;
    N3: TMenuItem;
    T1: TMenuItem;
    N4: TMenuItem;
    Undo1: TMenuItem;
    Repeat1: TMenuItem;
    PrinterSetupDialog1: TPrinterSetupDialog;
    RadioGroup1: TRadioGroup;
    Metafile1: TMenuItem;
    JPEG1: TMenuItem;
    PrintPreview1: TMenuItem;
    Print1: TMenuItem;
    DropBMPSource1: TDropBMPSource;
    Edit7: TEdit;
    UpDown1: TUpDown;
    Label7: TLabel;
    Button7: TButton;
    CheckBox1: TCheckBox;
    Label8: TLabel;
    Edit8: TEdit;
    Label9: TLabel;
    Edit9: TEdit;
    CheckBox3: TCheckBox;
    Button8: TButton;
    Option1: TMenuItem;
    Q1: TMenuItem;
    PopupMenu1: TPopupMenu;
    N10: TMenuItem;
    N11: TMenuItem;
    N12: TMenuItem;
    N13: TMenuItem;
    N14: TMenuItem;
    N15: TMenuItem;
    ColorDialog1: TColorDialog;
    N17: TMenuItem;
    N18: TMenuItem;
    N19: TMenuItem;
    N20: TMenuItem;
    N16: TMenuItem;
    Button9: TButton;
    N22: TMenuItem;
    N23: TMenuItem;
    N24: TMenuItem;
    N25: TMenuItem;
    N26: TMenuItem;
    N27: TMenuItem;
    N28: TMenuItem;
    ComboBox1: TComboBox;
    Label10: TLabel;
    N5: TMenuItem;
    N6: TMenuItem;
    procedure FormShow(Sender: TObject);
    procedure Button1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Button2MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Button3MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Button4MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Edit2KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Edit3KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Edit4KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Edit5KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Edit6KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure SearchforHelpOn1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure Bitmap1Click(Sender: TObject);
    procedure Save1Click(Sender: TObject);
    procedure Save2Click(Sender: TObject);
    procedure Open1Click(Sender: TObject);
    procedure Undo1Click(Sender: TObject);
    procedure Edit1Click(Sender: TObject);
    procedure Repeat1Click(Sender: TObject);
    procedure T1Click(Sender: TObject);
    procedure RadioGroup1Click(Sender: TObject);
    procedure Metafile1Click(Sender: TObject);
    procedure JPEG1Click(Sender: TObject);
    procedure Mandelbrot1PaintedMandel(Sender: TObject; Done: Integer);
    procedure PrintPreview1Click(Sender: TObject);
    procedure Print1Click(Sender: TObject);
    procedure Mandelbrot1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Mandelbrot1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Mandelbrot2MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Mandelbrot2MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Button7Click(Sender: TObject);
    procedure Edit8KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Edit9KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Button8Click(Sender: TObject);
    procedure Q1Click(Sender: TObject);
    procedure Mandelbrot1DblClick(Sender: TObject);
    procedure Mandelbrot2DblClick(Sender: TObject);
    procedure Mandelbrot1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PopupMenu1Popup(Sender: TObject);
    procedure N10Click(Sender: TObject);
    procedure N12Click(Sender: TObject);
    procedure N13Click(Sender: TObject);
    procedure N14Click(Sender: TObject);
    procedure N18Click(Sender: TObject);
    procedure N19Click(Sender: TObject);
    procedure N20Click(Sender: TObject);
    procedure N16Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure N22Click(Sender: TObject);
    procedure N23Click(Sender: TObject);
    procedure N24Click(Sender: TObject);
    procedure N25Click(Sender: TObject);
    procedure N26Click(Sender: TObject);
    procedure N27Click(Sender: TObject);
    procedure N28Click(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure N5Click(Sender: TObject);
    procedure N6Click(Sender: TObject);
  private
    { Private 錾 }
    DragPoint: TPoint;
    MovePoint: TPoint;
    Drawing: Integer;
    procedure MRectangle(MR: TRealRect);
    procedure DispInfor(History: Boolean);
    procedure CheckValues(SizeOption: Boolean);
    function Stream2Clipboard(Format: Word; MemStream: TMemoryStream): Boolean;
    // function NonExistName(FileName: String; Numeric: Boolean): String;
  public
    { Public 錾 }
    DataDir: String;
    HuffmanDir: String;
    HIndex: Integer;
    HMStep: array[1..32] of Extended;
    HMRect: array[1..32] of TRealRect;
    HColorOffset: array[1..32] of Integer;
    HReversColor: array[1..32] of Boolean;
    HMonochrome: array[1..32] of Boolean;
    HBackColor: array[1..32] of Integer;
    HJulia: array[1..32] of Boolean;
    HJCC: array[1..32] of TRealPoint;
    HMCount: array[1..32] of Integer;
    Fractal: Integer; // tN^̎ނ\킷ϐ
    pW, cW, cG, cN, kN, rC: Integer;
    pC, sC, bC: TColor;
    CanN6: Boolean;
  end;

var
  FrameForm: TFrameForm;

implementation

uses Preview, Color;

{$R *.DFM}

procedure TFrameForm.DispInfor(History: Boolean);
var
  MR: TRealRect;
  CR: TRect;
  JC: TRealPoint;
  i: Integer;
  w, h: Integer;
begin
  MR:= Mandelbrot1.MRect;
  CR := Mandelbrot1.CRect;
  JC := Mandelbrot1.JCC;
  w := CR.Right - CR.Left + 1;
  h := CR.Bottom - CR.Top + 1;

  Edit2.Text := Format('%g', [Mandelbrot1.MStep]);
  Edit3.Text := Format('%g', [MR.Left]);
  Edit4.Text := Format('%g', [MR.Top]);
  Edit5.Text := Format('%g', [MR.Right]);
  Edit6.Text := Format('%g', [MR.Bottom]);
  CheckBox1.Checked := Mandelbrot1.ReversColor;
  CheckBox3.Checked := Mandelbrot1.Monochrome;
  UpDown1.Position := Mandelbrot1.MCount;
  ComboBox1.ItemIndex := Fractal;
  Edit8.Text := Format('%g', [JC.X]);
  Edit9.Text := Format('%g', [JC.Y]);

  Caption := 'Mandelbrot Viewer Version 2.1';
  Caption := Caption + ' : ' + Mandelbrot1.STime;
  Caption := Caption + Format(' : %d ~ %d Pixels', [w, h]);

  Mandelbrot2.ColorOffset := Mandelbrot1.ColorOffset;
  Mandelbrot2.ReversColor := Mandelbrot1.ReversColor;
  Mandelbrot2.Monochrome := Mandelbrot1.Monochrome;
  Mandelbrot2.BackColor := Mandelbrot1.BackColor;  
  Mandelbrot2.Julia := Mandelbrot1.Julia;
  Mandelbrot2.JCC := Mandelbrot1.JCC;
  Mandelbrot2.MCount := Mandelbrot1.MCount;
  Mandelbrot2.MExecute;
  MRectangle(MR);

  if History then
  begin
    if HIndex < 32 then
    begin
      Inc(Hindex);
      for i := 32 downto HIndex + 1 do
      begin
        HMStep[i] := HMStep[i - 1];
        HMRect[i] := HMRect[i - 1];
        HColorOffset[i] := HColorOffset[i - 1];
        HReversColor[i] := HReversColor[i - 1];
        HMonochrome[i] := HMonochrome[i - 1];
        HBackColor[i] := HBackColor[i - 1];
        HJulia[i] := HJulia[i - 1];
        HJCC[i] := HJCC[i - 1];
        HMCount[i] := HMCount[i - 1];
      end;
    end
    else // HIndex = 32
    begin
      for i := 1 to 31 do
      begin
        HMStep[i] := HMStep[i + 1];
        HMRect[i] := HMRect[i + 1];
        HColorOffset[i] := HColorOffset[i + 1];
        HReversColor[i] := HReversColor[i + 1];
        HMonochrome[i] := HMonochrome[i + 1];
        HBackColor[i] := HBackColor[i + 1];
        HJulia[i] := HJulia[i + 1];
        HJCC[i] := HJCC[i + 1];
        HMCount[i] := HMCount[i + 1];
      end;
    end;
    HMStep[HIndex] := Mandelbrot1.MStep;
    HMRect[HIndex] := Mandelbrot1.MRect;
    HColorOffset[HIndex] := Mandelbrot1.ColorOffset;
    HReversColor[HIndex] := Mandelbrot1.ReversColor;
    HMonochrome[HIndex] := Mandelbrot1.Monochrome;
    HBackColor[HIndex] := Mandelbrot1.BackColor;
    HJulia[HIndex] := Mandelbrot1.Julia;
    HJCC[HIndex] := Mandelbrot1.JCC;
    HMCount[HIndex] := Mandelbrot1.MCount;
  end;
end;

procedure TFrameForm.CheckValues(SizeOption: Boolean);
var
  MS: Extended;
  MR: TRealRect;
  JC: TRealPoint;
begin
  try
    MS := StrToFloat(Edit2.Text);
    MR.Left := StrToFloat(Edit3.Text);
    MR.Top := StrToFloat(Edit4.Text);
    MR.Right := StrToFloat(Edit5.Text);
    MR.Bottom := StrToFloat(Edit6.Text);
    JC.X := StrToFloat(Edit8.Text);
    JC.Y := StrToFloat(Edit9.Text);
  except
    MS := 999;
  end;

  if MS = 999 then
  begin
    ShowMessage('l̓͂܂B');
    DispInfor(False);
    Exit;
  end;

  if (MS > MAXSTEP) or (MS < MINSTEP) then
  begin
    ShowMessage('͒lzĂ܂B');
    DispInfor(False);
    Exit;
  end;

  Mandelbrot1.MRect := MR;
  Mandelbrot1.SizeOption := SizeOption;
  Mandelbrot1.MStep := MS;
  Mandelbrot1.SizeOption := False;
  Mandelbrot1.JCC := JC;
  Caption := 'vZłB΂炭҂B';
  Mandelbrot1.MExecute;
end;

function TFrameForm.Stream2Clipboard(Format: Word; MemStream: TMemoryStream): Boolean;
var
  Data: THandle;
  DataPtr: Pointer;
begin
  Result := False;
  if MemStream.Size = 0 then
    Exit;
  Data := GlobalAlloc(GMEM_MOVEABLE or GMEM_DDESHARE, MemStream.Size);
  try
    DataPtr := GlobalLock(Data);
    try
      MemStream.Position := 0;
      MemStream.ReadBuffer(DataPtr^, MemStream.Size);
      MemStream.Position := 0;
    finally
      GlobalUnlock(Data);
    end;
    Clipboard.SetAsHandle(Format, Data);
  except
    GlobalFree(Data);
    raise;
  end;
  Result := True;
end;

{ FileName x[XƂẴtH_ɑ݂Ȃt@CԂ֐łB}
{ Numeric = True ̏ꍇ́AgĐVt@C܂B܂ }
{ Numeric = False ̏ꍇ́AAt@xbggĐVt@C܂B}
{
function TFrameForm.NonExistName(FileName: String; Numeric: Boolean): String;
var
  FName, FAdd, FExt: String;
  i, j: Integer;
begin
  Result := FileName;
  if not FileExists(Result) then
    Exit;

  FName := ChangeFileExt(FileName, '');
  FAdd := 'A';
  FExt := ExtractFileExt(FileName);

  if Numeric = False then // 'A' ` 'Z' gB
  begin
    i := Ord('A'); j := Ord('Z');
    while i <= j do
    begin
      FAdd[1] := Chr(i);
      Result := FName + FAdd + FExt;
      if not FileExists(Result) then
        Break;
      Inc(i);
    end;
    if i > j then // At@xbgŗLȃt@CoȂꍇ́A
      Numeric := True; // gĐVt@C܂B
  end;

  if Numeric = True then // '0' ` '9999' ̐gB
  begin
    i := 0;
    while i < 10000 do
    begin
      FAdd := IntToStr(i);
      Result := FName + FAdd + FExt;
      if not FileExists(Result) then
        Break;
      Inc(i);
    end;
    if i = 10000 then
    begin
      FAdd := '_';
      Result := FName + FAdd + FExt;
    end;
  end;
end;
}

procedure TFrameForm.FormShow(Sender: TObject);
var
  i: Integer;
  MR: TRealRect;
  JC: TRealPoint;
  ExeName: String;
begin
  DataDir := ExtractFilePath(Application.ExeName) + 'Data';
  if not DirectoryExists(DataDir) then
    CreateDir(DataDir);

  HuffmanDir := ExtractFilePath(Application.ExeName) + 'HuffmanData';
  if not DirectoryExists(HuffmanDir) then
    CreateDir(HuffmanDir);

  ExeName := ExtractFilePath(Application.ExeName) + 'HuffGen.exe';
  if FileExists(ExeName) then
    CanN6 := True
  else
    CanN6 := False;

  Fractal := 0; // Mandelbrot set
  Drawing := 0;
  pW := 2; // ̑(1`5) --- Koch curve, Hilbert curve, Peano curve, Dragon curve, Levy C curve
  cW := 10; // ̑(1`20) --- Cantor set
  cG := 10; // Mbv(1`20) --- Cantor set
  cN := 4; // np`̊p(0,3`32) --- Cantor set
  kN := 3; // np`̊p(0,3`32) --- Koch curve
  rC := 4; // ċẢ(0`30)
  pC := clBlack; // ̐F
  bC := clWhite; // wiF
  HIndex := 0;
  for i := 1 to 32 do
  begin
    HMStep[i] := 999;
    HMRect[i] := RealRect(999, 999, 999, 999);
    HColorOffset[i] := 0;
    HReversColor[i] := False;
    HMonochrome[i] := False;
    HBackColor[i] := CMAX;
    HJulia[i] := False;
    HJCC[i] := RealPoint(999, 999);
    HMCount[i] := 256;
  end;

  Parameter1.Init; // Parameter1 Ăep[^t@C烍[hB
  if Parameter1.Count > 0 then // p[^̃[hɐꍇ
  begin
    Left := Parameter1['Left']; // Integer ^̃f[^𓾂B(Parameter1.VIntegers['Left'] ƓłB)
    Top := Parameter1['Top']; // Integer ^̃f[^𓾂B
    ClientWidth := Parameter1['ClientWidth']; // Integer ^̃f[^𓾂B
    ClientHeight := Parameter1['ClientHeight']; // Integer ^̃f[^𓾂B
    WindowState := TWindowState(Parameter1['WindowState']); // Integer ^̃f[^𓾂B
    Mandelbrot1.MStep := Parameter1.VExtends['MStep']; // Extended  ^̃f[^𓾂B
    MR.Left := Parameter1.VExtends['MRect.Left']; // Extended  ^̃f[^𓾂B
    MR.Top := Parameter1.VExtends['MRect.Top']; // Extended  ^̃f[^𓾂B
    MR.Right := Parameter1.VExtends['MRect.Right']; // Extended  ^̃f[^𓾂B
    MR.Bottom := Parameter1.VExtends['MRect.Bottom']; // Extended  ^̃f[^𓾂B
    Mandelbrot1.MRect := MR;
    Mandelbrot1.ColorOffset := Parameter1['ColorOffset'];
    Mandelbrot1.ReversColor := Parameter1.VBools['ReversColor'];
    Mandelbrot1.Monochrome := Parameter1.VBools['Monochrome'];
    Mandelbrot1.BackColor := Parameter1['BackColor'];
    Mandelbrot1.Julia := Parameter1.VBools['Julia'];
    JC.X := Parameter1.VExtends['JCC.X'];
    JC.Y := Parameter1.VExtends['JCC.Y'];
    Mandelbrot1.JCC := JC;
    Mandelbrot1.MCount := Parameter1['MCount'];
    RadioGroup1.ItemIndex := Parameter1['RadioGroup1.ItemIndex']; // Integer ^̃f[^𓾂B
    pC := TColor(Parameter1['pC']); // Integer ^̃f[^𓾂B
    bC := TColor(Parameter1['bC']); // Integer ^̃f[^𓾂B
  end
  else // p[^[hoȂꍇ
  begin
    Parameter1.Add('Mandelbrot Viewer ݒt@C --- ̃t@ĆAҏWȂŉB');
    Parameter1['Left'] := Left; // Parameter1.VIntegers['Left'] ƓłB
    Parameter1['Top'] := Top;
    ClientWidth := 684; Parameter1['ClientWidth'] := ClientWidth;
    ClientHeight := 544; Parameter1['ClientHeight'] := ClientHeight;
    Parameter1['WindowState'] := Integer(WindowState);
    Parameter1.VExtends['MStep'] := Mandelbrot1.MStep;
    MR := Mandelbrot1.MRect;
    Parameter1.VExtends['MRect.Left'] := MR.Left;
    Parameter1.VExtends['MRect.Top'] := MR.Top;
    Parameter1.VExtends['MRect.Right'] := MR.Right;
    Parameter1.VExtends['MRect.Bottom'] := MR.Bottom;
    Parameter1['ColorOffset'] := Mandelbrot1.ColorOffset;
    Parameter1.VBools['ReversColor'] := Mandelbrot1.ReversColor;
    Parameter1.VBools['Monochrome'] := Mandelbrot1.Monochrome;
    Parameter1['BackColor'] := Mandelbrot1.BackColor;
    Parameter1.VBools['Julia'] := Mandelbrot1.Julia;
    JC := Mandelbrot1.JCC;
    Parameter1.VExtends['JCC.X'] := JC.X;
    Parameter1.VExtends['JCC.Y'] := JC.Y;
    Parameter1['MCount'] := Mandelbrot1.MCount;
    Parameter1['RadioGroup1.ItemIndex'] := RadioGroup1.ItemIndex;
    { vr[tH[p̃f[^ }
    Parameter1['PLeft'] := 240;
    Parameter1['PTop'] := 235;
    Parameter1['PClientWidth'] := 350;
    Parameter1['PClientHeight'] := 340;
    Parameter1['PWindowState'] := Integer(wsNormal);
    Parameter1['PrintRatio'] := 100;
    Parameter1['PreviewRatio'] := 20;
    Parameter1['GraphicMode'] := 0; // gmMetafile
    { F̐ݒ_CAOp̃f[^ }
    Parameter1['CLeft'] := 192;
    Parameter1['CTop'] := 114;
    { 炻̑̃tN^p̃f[^ }
    Parameter1['pC'] := Integer(pC); // Integer ^̃f[^𓾂B
    Parameter1['bC'] := Integer(bC); // Integer ^̃f[^𓾂B
  end;
  sC := pC; // Standard color

  if RadioGroup1.ItemIndex = 0 then
    Mandelbrot1.Ruler := False
  else
  begin
    Mandelbrot1.Ruler := True;
    if RadioGroup1.ItemIndex = 1 then
      Mandelbrot1.RulerCount := 3
    else if RadioGroup1.ItemIndex = 2 then
      Mandelbrot1.RulerCount := 5
    else
      Mandelbrot1.RulerCount := 10;
  end;

  Mandelbrot2.MStep := 0.02200;
  // Mandelbrot2.MRect := RealRect(-2.0300, 1.2500, 0.9300, -1.2500);
  // Mandelbrot2.MExecute;
  if Mandelbrot1.MTime = 0 then
  begin
    Caption := 'vZłB΂炭҂B';
    Mandelbrot1.MExecute;
  end
  else
    DispInfor(True);
end;

procedure TFrameForm.MRectangle(MR: TRealRect);
var
  CR: TRect;
  CP: TPoint;
  w, h: Integer;
begin
  CR.TopLeft := Mandelbrot2.M2C(MR.TopLeft);
  CR.BottomRight := Mandelbrot2.M2C(MR.BottomRight);
  w := CR.Right - CR.Left + 1;
  h := CR.Bottom - CR.Top + 1;
  CP.X := (CR.Left + CR.Right) div 2;
  CP.Y := (CR.Top + CR.Bottom) div 2;

  Mandelbrot2.Canvas.Pen.Color := clBlue;
  Mandelbrot2.Canvas.Pen.Width := 2;
  if (w > 12) or (h > 12) then
  begin
    Mandelbrot2.Canvas.MoveTo(CR.Left, CR.Top);
    Mandelbrot2.Canvas.LineTo(CR.Right, CR.Top);
    Mandelbrot2.Canvas.LineTo(CR.Right, CR.Bottom);
    Mandelbrot2.Canvas.LineTo(CR.Left, CR.Bottom);
    Mandelbrot2.Canvas.LineTo(CR.Left, CR.Top);
  end;

  Mandelbrot2.Canvas.Pen.Width := 3;
  Mandelbrot2.Canvas.MoveTo(CP.X - 5, CP.Y);
  Mandelbrot2.Canvas.LineTo(CP.X + 5, CP.Y);
  Mandelbrot2.Canvas.MoveTo(CP.X, CP.Y - 5);
  Mandelbrot2.Canvas.LineTo(CP.X, CP.Y + 5);
end;

procedure TFrameForm.Button1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  r: Extended;
begin
  if ssShift in Shift then
    r := 2
  else if ssCtrl in Shift then
    r := Sqrt(Sqrt(2))
  else if ssAlt in Shift then
    r := Sqrt(Sqrt(Sqrt(2)))
  else
    r := Sqrt(2);

  Mandelbrot1.SizeOption := True;
  Mandelbrot1.MStep := Mandelbrot1.MStep / r;
  Mandelbrot1.SizeOption := False;
  Caption := 'vZłB΂炭҂B';
  Mandelbrot1.MExecute;
end;

procedure TFrameForm.Button2MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  r: Extended;
begin
  if ssShift in Shift then
    r := 2
  else if ssCtrl in Shift then
    r := Sqrt(Sqrt(2))
  else if ssAlt in Shift then
    r := Sqrt(Sqrt(Sqrt(2)))
  else
    r := Sqrt(2);

  Mandelbrot1.SizeOption := True;
  Mandelbrot1.MStep := Mandelbrot1.MStep * r;
  Mandelbrot1.SizeOption := False;
  Caption := 'vZłB΂炭҂B';
  Mandelbrot1.MExecute;
end;

procedure TFrameForm.Button3MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  r: Extended;
begin
  if ssShift in Shift then
    r := Sqrt(2)
  else if ssCtrl in Shift then
    r := Sqrt(Sqrt(Sqrt(2)))
  else if ssAlt in Shift then
    r := Sqrt(Sqrt(Sqrt(Sqrt(2))))
  else
    r := Sqrt(Sqrt(2));

  Mandelbrot1.MStep := Mandelbrot1.MStep / r;
  Caption := 'vZłB΂炭҂B';
  Mandelbrot1.MExecute;
end;

procedure TFrameForm.Button4MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  r: Extended;
begin
  if ssShift in Shift then
    r := Sqrt(2)
  else if ssCtrl in Shift then
    r := Sqrt(Sqrt(Sqrt(2)))
  else if ssAlt in Shift then
    r := Sqrt(Sqrt(Sqrt(Sqrt(2))))
  else
    r := Sqrt(Sqrt(2));

  Mandelbrot1.MStep := Mandelbrot1.MStep * r;
  Caption := 'vZłB΂炭҂B';
  Mandelbrot1.MExecute;
end;

procedure TFrameForm.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
var
  MR: TRealRect;
  JC: TRealPoint;
begin
  if WindowState <> wsMaximized then
  begin
    Parameter1['Left'] := Left;
    Parameter1['Top'] := Top;
    Parameter1['ClientWidth'] := ClientWidth;
    Parameter1['ClientHeight'] := ClientHeight;
  end;
  Parameter1['WindowState'] := Integer(WindowState);
  Parameter1.VExtends['MStep'] := Mandelbrot1.MStep;
  MR := Mandelbrot1.MRect;
  Parameter1.VExtends['MRect.Left'] := MR.Left;
  Parameter1.VExtends['MRect.Top'] := MR.Top;
  Parameter1.VExtends['MRect.Right'] := MR.Right;
  Parameter1.VExtends['MRect.Bottom'] := MR.Bottom;
  Parameter1['ColorOffset'] := Mandelbrot1.ColorOffset;
  Parameter1.VBools['ReversColor'] := Mandelbrot1.ReversColor;
  Parameter1.VBools['Monochrome'] := Mandelbrot1.Monochrome;
  Parameter1['BackColor'] := Mandelbrot1.BackColor;
  Parameter1.VBools['Julia'] := Mandelbrot1.Julia;
  JC := Mandelbrot1.JCC;
  Parameter1.VExtends['JCC.X'] := JC.X;
  Parameter1.VExtends['JCC.Y'] := JC.Y;
  Parameter1['MCount'] := Mandelbrot1.MCount;
  Parameter1['RadioGroup1.ItemIndex'] := RadioGroup1.ItemIndex;
  Parameter1['pC'] := Integer(sC); // Standard color
  Parameter1['bC'] := Integer(bC);

  Parameter1.SaveToFile;
end;

procedure TFrameForm.Button5Click(Sender: TObject);
begin
  Mandelbrot1.MStep := 0.0070;
  Mandelbrot1.MRect := RealRect(-2.0900, 2.1000, 2.1100, -2.1000);
  Caption := 'vZłB΂炭҂B';
  Mandelbrot1.MExecute;
end;

procedure TFrameForm.Button6Click(Sender: TObject);
var
  MR: TRealRect;
  JC: TRealPoint;
begin
  Mandelbrot1.MStep := Parameter1.VExtends['MStep'];
  MR.Left := Parameter1.VExtends['MRect.Left'];
  MR.Top := Parameter1.VExtends['MRect.Top'];
  MR.Right := Parameter1.VExtends['MRect.Right'];
  MR.Bottom := Parameter1.VExtends['MRect.Bottom'];
  Mandelbrot1.MRect := MR;
  Mandelbrot1.ColorOffset := Parameter1['ColorOffset'];
  Mandelbrot1.ReversColor := Parameter1.VBools['ReversColor'];
  Mandelbrot1.Monochrome := Parameter1.VBools['Monochrome'];
  Mandelbrot1.BackColor := Parameter1['BackColor'];
  Mandelbrot1.Julia := Parameter1.VBools['Julia'];
  JC.X := Parameter1.VExtends['JCC.X'];
  JC.Y := Parameter1.VExtends['JCC.Y'];
  Mandelbrot1.JCC := JC;
  Mandelbrot1.MCount := Parameter1['MCount'];
  Caption := 'vZłB΂炭҂B';
  Mandelbrot1.MExecute;
end;

procedure TFrameForm.Edit2KeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = $0D then
  begin
    Tag := 1;
    Button7Click(Sender);
  end;
end;

procedure TFrameForm.Edit3KeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = $0D then
    Button7Click(Sender);
end;

procedure TFrameForm.Edit4KeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = $0D then
    Button7Click(Sender);
end;

procedure TFrameForm.Edit5KeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = $0D then
    Button7Click(Sender);
end;

procedure TFrameForm.Edit6KeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = $0D then
    Button7Click(Sender);
end;

procedure TFrameForm.SearchforHelpOn1Click(Sender: TObject);
var
  FileName: TFileName;
begin
  FileName := ExtractFilePath(Application.ExeName) + 'Readme.txt';
  ShellExecute(Handle, PChar('open'), PChar(FileName), Nil, Nil, SW_SHOW);
end;

procedure TFrameForm.About1Click(Sender: TObject);
begin
  ShellAbout(Handle, PChar(Application.Title),
             #13#10 + 'Mandelbrot Viewer Version 2.1 Copyright (C) 2016 ` 2022 seizo',
             Application.Icon.Handle);

  HuffmanFrequency(Mandelbrot1.FrequencyM,
                   256,
                   DataDir + '\FrequencyM.fre',
                   False);
end;

procedure TFrameForm.Exit1Click(Sender: TObject);
begin
  Close;
end;

procedure TFrameForm.Bitmap1Click(Sender: TObject);
begin
  Clipboard.Assign(Mandelbrot1.Picture.Bitmap);
end;

procedure TFrameForm.Save1Click(Sender: TObject);
var
  Ext: String;
  S: String;
  R: TRect;
  Bmp: TBitmap;
  Mf: TMetafile;
  MfCanvas: TMetafileCanvas;
  Jpeg: TJPEGImage;
begin
  if Mandelbrot1.Picture.Graphic = Nil then
    Exit;

  R := Rect(0, 0, Mandelbrot1.Width, Mandelbrot1.Height);

  SaveDialog1.InitialDir := DataDir;

  if Fractal = 1 then // Julia set
  begin
    if Pos('Julia', ExtractFileName(OpenDialog1.Filename)) > 0 then
      SaveDialog1.FileName := ChangeFileExt(ExtractFileName(OpenDialog1.Filename), '')
    else
      SaveDialog1.FileName := 'Julia';
  end
  else // Mandelbrot set
  begin
    if Pos('Mandel', ExtractFileName(OpenDialog1.Filename)) > 0 then
      SaveDialog1.FileName := ChangeFileExt(ExtractFileName(OpenDialog1.Filename), '')
    else
      SaveDialog1.FileName := 'Mandel';
  end;

  if SaveDialog1.Execute then
  begin
    if Pos('.', SaveDialog1.Filename) = 0 then
    begin
      case SaveDialog1.FilterIndex of
        1: SaveDialog1.Filename := SaveDialog1.Filename + '.bmp';
        2: SaveDialog1.Filename := SaveDialog1.Filename + '.jpg';
        3: SaveDialog1.Filename := SaveDialog1.Filename + '.jpeg';
        4: SaveDialog1.Filename := SaveDialog1.Filename + '.emf';
        5: SaveDialog1.Filename := SaveDialog1.Filename + '.wmf';
      else
        SaveDialog1.Filename := SaveDialog1.Filename + '.bmp';
      end;
    end;
    Ext := LowerCase(ExtractFileExt(SaveDialog1.FileName));

    if FileExists(SaveDialog1.FileName) then
    begin
      S := SaveDialog1.FileName + #13#10 + #13#10 +
           '͂łɑ݂܂B㏑܂?';
      if MessageDlg(S, mtConfirmation, [mbYes, mbNo], 0) <> mrYes then
        Exit;
    end;

    if Ext = '.bmp' then
    begin
      Bmp := TBitmap.Create;
      try
        Bmp.Width := Mandelbrot1.Width;
        Bmp.Height := Mandelbrot1.Height;
        Bmp.Canvas.StretchDraw(R, Mandelbrot1.Picture.Graphic);
        Bmp.SaveToFile(SaveDialog1.Filename);
      finally
        Bmp.Free;
      end;
    end
    else if (Ext = '.emf') or (Ext = '.wmf') then
    begin
      Mf := TMetafile.Create;
      if Ext = '.emf' then
        Mf.Enhanced := True
      else
        Mf.Enhanced := False;
      try
        Mf.Width := Mandelbrot1.Width;
        Mf.Height := Mandelbrot1.Height;
        MfCanvas := TMetafileCanvas.Create(Mf, GetDC(0));
        try
          MfCanvas.StretchDraw(R, Mandelbrot1.Picture.Graphic);
        finally
          MfCanvas.Free;
        end;
        Mf.SaveToFile(SaveDialog1.Filename);
      finally
        Mf.Free;
      end;
    end
    else if (Ext = '.jpg') or (Ext = '.jpeg') then
    begin
      Bmp := TBitmap.Create;
      try
        Bmp.Width := Mandelbrot1.Width;
        Bmp.Height := Mandelbrot1.Height;
        Bmp.Canvas.StretchDraw(R, Mandelbrot1.Picture.Graphic);
        Jpeg := TJPEGImage.Create;
        Jpeg.CompressionQuality := 100;
        try
          Jpeg.Assign(Bmp);
          Jpeg.SaveToFile(SaveDialog1.Filename);
        finally
          Jpeg.Free;
        end;
      finally
        Bmp.Free;
      end;
    end
    else
      Mandelbrot1.Picture.SaveToFile(SaveDialog1.Filename);
  end;
end;

procedure TFrameForm.Save2Click(Sender: TObject);
var
  MR: TRealRect;
  JC: TRealPoint;
  S: String;
begin
  if Fractal > 1 then
    Exit;

  SaveDialog2.InitialDir := DataDir;

  if Fractal = 1 then // Julia set
  begin
    if Pos('Julia', ExtractFileName(OpenDialog1.Filename)) > 0 then
      SaveDialog2.FileName := ChangeFileExt(ExtractFileName(OpenDialog1.Filename), '.bro')
    else
      SaveDialog2.FileName := 'Julia.bro';
  end
  else // Mandelbrot set
  begin
    if Pos('Mandel', ExtractFileName(OpenDialog1.Filename)) > 0 then
      SaveDialog2.FileName := ChangeFileExt(ExtractFileName(OpenDialog1.Filename), '.bro')
    else
      SaveDialog2.FileName := 'Mandel.bro';
  end;

  if SaveDialog2.Execute then
  begin
    if Pos('.', SaveDialog2.Filename) = 0 then
      SaveDialog2.Filename := SaveDialog2.Filename + '.bro';

    if FileExists(SaveDialog2.FileName) then
    begin
      S := SaveDialog2.FileName + #13#10 + #13#10 +
           '͂łɑ݂܂B㏑܂?';
      if MessageDlg(S, mtConfirmation, [mbYes, mbNo], 0) <> mrYes then
        Exit;
    end;

    Parameter2.Dir := ExtractFileDir(SaveDialog2.Filename);
    Parameter2.FileName := ExtractFileName(SaveDialog2.Filename);

    Parameter2.VExtends['MStep'] := Mandelbrot1.MStep;
    MR := Mandelbrot1.MRect;
    Parameter2.VExtends['MRect.Left'] := MR.Left;
    Parameter2.VExtends['MRect.Top'] := MR.Top;
    Parameter2.VExtends['MRect.Right'] := MR.Right;
    Parameter2.VExtends['MRect.Bottom'] := MR.Bottom;
    Parameter2['ColorOffset'] := Mandelbrot1.ColorOffset;
    Parameter2.VBools['ReversColor'] := Mandelbrot1.ReversColor;
    Parameter2.VBools['Monochrome'] := Mandelbrot1.Monochrome;
    Parameter2['BackColor'] := Mandelbrot1.BackColor;
    Parameter2.VBools['Julia'] := Mandelbrot1.Julia;
    JC := Mandelbrot1.JCC;
    Parameter2.VExtends['JCC.X'] := JC.X;
    Parameter2.VExtends['JCC.Y'] := JC.Y;
    Parameter2['MCount'] := Mandelbrot1.MCount;

    Parameter2.SaveToFile;
  end;
end;

procedure TFrameForm.Open1Click(Sender: TObject);
var
  err: Boolean;
  MR: TRealRect;
  JC: TRealPoint;
begin
  OpenDialog1.InitialDir := DataDir;
  if OpenDialog1.FileName = '' then
  begin
    if Fractal = 1 then
      OpenDialog1.FileName := 'Julia.bro'
    else
      OpenDialog1.FileName := 'Mandel.bro';
  end;

  if OpenDialog1.Execute then
  begin
    Parameter2.Dir := ExtractFileDir(OpenDialog1.Filename);
    Parameter2.FileName := ExtractFileName(OpenDialog1.Filename);

    err := False;
    try
      Parameter2.Init;
    except
      err := True;
    end;

    if (not err) and (Parameter2.Count > 0) then
    begin
      Mandelbrot1.MStep := Parameter2.VExtends['MStep'];
      MR.Left := Parameter2.VExtends['MRect.Left'];
      MR.Top := Parameter2.VExtends['MRect.Top'];
      MR.Right := Parameter2.VExtends['MRect.Right'];
      MR.Bottom := Parameter2.VExtends['MRect.Bottom'];
      Mandelbrot1.MRect := MR;
      Mandelbrot1.ColorOffset := Parameter2['ColorOffset'];
      Mandelbrot1.ReversColor := Parameter2.VBools['ReversColor'];
      Mandelbrot1.Monochrome := Parameter2.VBools['Monochrome'];
      Mandelbrot1.BackColor := Parameter2['BackColor'];
      Mandelbrot1.Julia := Parameter2.VBools['Julia'];
      JC.X := Parameter2.VExtends['JCC.X'];
      JC.Y := Parameter2.VExtends['JCC.Y'];
      Mandelbrot1.JCC := JC;
      Mandelbrot1.MCount := Parameter2['MCount'];

      Caption := 'vZłB΂炭҂B';
      Mandelbrot1.MExecute;
    end;
  end;
end;

procedure TFrameForm.Undo1Click(Sender: TObject);
begin
  if HIndex < 2 then
    Exit;
  Dec(HIndex);
  Mandelbrot1.MStep := HMStep[HIndex];
  Mandelbrot1.MRect := HMRect[HIndex];
  Mandelbrot1.ColorOffset := HColorOffset[HIndex];
  Mandelbrot1.ReversColor := HReversColor[HIndex];
  Mandelbrot1.Monochrome := HMonochrome[HIndex];
  Mandelbrot1.BackColor := HBackColor[HIndex];
  Mandelbrot1.Julia := HJulia[HIndex];
  Mandelbrot1.JCC := HJCC[HIndex];
  Mandelbrot1.MCount := HMCount[HIndex];
  Caption := 'vZłB΂炭҂B';
  Tag := -1; // History XVȂꍇ
  Mandelbrot1.MExecute;
end;

procedure TFrameForm.Edit1Click(Sender: TObject);
begin
  if HIndex > 1 then
    Undo1.Enabled := True
  else
    Undo1.Enabled := False;

  if (HIndex < 32) and (HMStep[HIndex + 1] <> 999) then
    Repeat1.Enabled := True
  else
    Repeat1.Enabled := False;
end;

procedure TFrameForm.Repeat1Click(Sender: TObject);
begin
  if (HIndex > 31) or (HMStep[HIndex + 1] = 999) then
    Exit;
  Inc(HIndex);
  Mandelbrot1.MStep := HMStep[HIndex];
  Mandelbrot1.MRect := HMRect[HIndex];
  Mandelbrot1.ColorOffset := HColorOffset[HIndex];
  Mandelbrot1.ReversColor := HReversColor[HIndex];
  Mandelbrot1.Monochrome := HMonochrome[HIndex];
  Mandelbrot1.BackColor := HBackColor[HIndex];
  Mandelbrot1.Julia := HJulia[HIndex];
  Mandelbrot1.JCC := HJCC[HIndex];
  Mandelbrot1.MCount := HMCount[HIndex];
  Caption := 'vZłB΂炭҂B';
  Tag := -1; // History XVȂꍇ
  Mandelbrot1.MExecute;
end;

procedure TFrameForm.T1Click(Sender: TObject);
begin
  PrinterSetupDialog1.Execute;
end;

procedure TFrameForm.RadioGroup1Click(Sender: TObject);
begin
  if RadioGroup1.ItemIndex = 0 then
    Mandelbrot1.Ruler := False
  else
  begin
    Mandelbrot1.Ruler := True;
    if RadioGroup1.ItemIndex = 1 then
      Mandelbrot1.RulerCount := 3
    else if RadioGroup1.ItemIndex = 2 then
      Mandelbrot1.RulerCount := 5
    else
      Mandelbrot1.RulerCount := 10;
  end;
  Caption := 'vZłB΂炭҂B';
  Tag := -1; // History XVȂꍇ
  Mandelbrot1.MExecute;
end;

procedure TFrameForm.Metafile1Click(Sender: TObject);
var
  Mf: TMetafile;
  MfCanvas: TMetafileCanvas;
begin
  Clipboard.Assign(Mandelbrot1.Picture.Bitmap);

  Mf := TMetafile.Create;
  try
    Mf.Width := Mandelbrot1.Width;
    Mf.Height := Mandelbrot1.Height;
    MfCanvas := TMetafileCanvas.Create(Mf, GetDC(0));
    try
      MfCanvas.Draw(0, 0, Mandelbrot1.Picture.Graphic);
    finally
      MfCanvas.Free;
    end;
    Clipboard.Assign(Mf);
  finally
    Mf.Free;
  end;
end;

procedure TFrameForm.JPEG1Click(Sender: TObject);
var
  Jpg: TJPEGImage;
  MemStream: TMemoryStream;
begin
  Jpg := TJPEGImage.Create;
  try
    Jpg.Assign(Mandelbrot1.Picture.Graphic);
    MemStream := TMemoryStream.Create;
    try
      Jpg.SaveToStream(MemStream);
      Stream2Clipboard(CF_JFIF, MemStream);
    finally
      MemStream.Free;
    end;
  finally
    Jpg.Free;
  end;
end;

procedure TFrameForm.Mandelbrot1PaintedMandel(Sender: TObject;
  Done: Integer);
begin
  if Mandelbrot1.Julia = True then
    Fractal := 1
  else
    Fractal := 0;
  if Done = 1 then // \ɐꍇ
  begin
    if Tag = -1 then
      DispInfor(False)
    else
      DispInfor(True);
  end
  else
  begin
    if Done = 0 then // sȃp[^̏ꍇ
      ShowMessage('sȃp[^̒lłB')
    else if Done = -1 then // \̃G[̏ꍇ
      ShowMessage('_ZG[łB');
    if HIndex > 0 then
    begin
      Caption := 'vZłB΂炭҂B';
      Mandelbrot1.MStep := HMStep[HIndex];
      Mandelbrot1.MRect := HMRect[HIndex];
      Mandelbrot1.ColorOffset := HColorOffset[HIndex];
      Mandelbrot1.ReversColor := HReversColor[HIndex];
      Mandelbrot1.Monochrome := HMonochrome[HIndex];
      Mandelbrot1.BackColor := HBackColor[HIndex];
      Mandelbrot1.Julia := HJulia[HIndex];
      Mandelbrot1.JCC := HJCC[HIndex];
      Mandelbrot1.MCount := HMCount[HIndex];
      Tag := -1; // History XVȂꍇ
      Mandelbrot1.MExecute;
    end
    else
      Button5Click(Sender);
  end;
  Tag := 0;
  Drawing := 0;
end;

procedure TFrameForm.PrintPreview1Click(Sender: TObject);
begin
  PreviewForm.ShowModal;
end;

procedure TFrameForm.Print1Click(Sender: TObject);
begin
  if PreviewForm.PrintDialog1.Execute then
    PreviewForm.GraphicPreview1.Print(PreviewForm.PrintDialog1.Copies);
end;

procedure TFrameForm.Mandelbrot1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  DragPoint := Point(X, Y);
  if (Fractal > 1) and (Drawing = 0) then // Mandelbrot set / Julia set ȊÕtN^
  begin
    Drawing := 1; // `Jn
    Mandelbrot1.Canvas.MoveTo(X, Y);
    MovePoint := DragPoint;
    Mandelbrot1.Canvas.Pen.Color := pC;
    Mandelbrot1.Canvas.Pen.Width := pW;
  end;
end;

procedure TFrameForm.Mandelbrot1MouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
  if (not (ssLeft in Shift)) or (Mandelbrot1.Picture.Graphic = Nil) then
    Exit;

  if (Fractal > 1) and (Drawing = 1) then
  begin
    Mandelbrot1.Canvas.MoveTo(DragPoint.X, DragPoint.Y);
    Mandelbrot1.Canvas.LineTo(MovePoint.X, MovePoint.Y);
    MovePoint := Point(X, Y);
    Mandelbrot1.Canvas.MoveTo(DragPoint.X, DragPoint.Y);
    Mandelbrot1.Canvas.LineTo(MovePoint.X, MovePoint.Y);
  end
  else
  begin
    if (Abs(X - DragPoint.X) < Mouse.DragThreshold) and
       (Abs(Y - DragPoint.Y) < Mouse.DragThreshold) then
      Exit;

    DropBMPSource1.Bitmap := Mandelbrot1.Picture.Bitmap;
    DropBMPSource1.Execute; // Do it here - dragging from Mandelbrot1.
  end;
end;

procedure TFrameForm.Mandelbrot2MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  DragPoint := Point(X, Y);
end;

procedure TFrameForm.Mandelbrot2MouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
  if (not (ssLeft in Shift)) or (Mandelbrot2.Picture.Graphic = Nil) then
    Exit;

  if (Abs(X - DragPoint.X) < Mouse.DragThreshold) and
     (Abs(Y - DragPoint.Y) < Mouse.DragThreshold) then
    Exit;

  DropBMPSource1.Bitmap := Mandelbrot2.Picture.Bitmap;
  DropBMPSource1.Execute; // Do it here - dragging from TurboImage1.
end;

procedure TFrameForm.Button7Click(Sender: TObject);
begin
  case ComboBox1.ItemIndex of
    0: Fractal := 0;
    1: Fractal := 1;
    2..11: begin
             if Mandelbrot1.Julia = True then
               Fractal := 1
             else
               Fractal := 0;
           end;
  end;

  if Fractal = 1 then // Julia set
    Mandelbrot1.Julia := True
  else
    Mandelbrot1.Julia := False;

  Mandelbrot1.ReversColor := CheckBox1.Checked;
  Mandelbrot1.Monochrome := CheckBox3.Checked;
  Mandelbrot1.MCount := UpDown1.Position;
  if Tag = 1 then
    CheckValues(True)
  else
    CheckValues(False);
end;

procedure TFrameForm.Edit8KeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = $0D then
    Button7Click(Sender);
end;

procedure TFrameForm.Edit9KeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = $0D then
    Button7Click(Sender);
end;

procedure TFrameForm.Button8Click(Sender: TObject);
var
  OldColorOffset, OldBackColor: Integer;
  OldbC: TColor;
  OldFractal: Integer;
begin
  OldColorOffset := Mandelbrot1.ColorOffset;
  OldBackColor := Mandelbrot1.BackColor;
  OldbC := bC;
  OldFractal := Fractal;
  if ColorForm.ShowModal = mrOk then
  begin
    if Fractal < 2 then
    begin
      if (Fractal <> OldFractal) or
         (Mandelbrot1.ColorOffset <> OldColorOffset) or
         (Mandelbrot1.BackColor <> OldBackColor) then
        Button7Click(Sender);
    end
    else
    begin
      Mandelbrot1.Canvas.Pen.Color := pC;
      if Fractal < 8 then
        sC := pC; // Standard color
      if (OldFractal < 2) or (bC <> OldbC) then
      begin
        Mandelbrot1.Canvas.Brush.Color := bC;
        Mandelbrot1.FractalInit(601, 601, pW, pC, bC);
        Mandelbrot1.Canvas.Pen.Mode := pmNotXor;
      end;
    end;
  end;
end;

procedure TFrameForm.Q1Click(Sender: TObject);
var
  MR: TRealRect;
  JC: TRealPoint;
begin
  Left := 197;
  Top := 114;
  ClientWidth := 684;
  ClientHeight := 544;
  WindowState := wsNormal;
  Mandelbrot1.MStep := 0.00700000000000000015;
  MR.Left := -2.09;
  MR.Top := 2.1;
  MR.Right := 2.11;
  MR.Bottom := -2.1;
  Mandelbrot1.MRect := MR;
  Mandelbrot1.ColorOffset := 0;
  Mandelbrot1.ReversColor := False;
  Mandelbrot1.Monochrome := False;
  Mandelbrot1.BackColor := 255;
  Mandelbrot1.Julia := False;
  JC.X := -0.159;
  JC.Y := -0.655;
  Mandelbrot1.JCC := JC;
  Mandelbrot1.MCount := 256;
  RadioGroup1.ItemIndex := 1;
  Parameter1['PLeft'] := 240;
  Parameter1['PTop'] := 235;
  Parameter1['PClientWidth'] := 350;
  Parameter1['PClientHeight'] := 340;
  Parameter1['PWindowState'] := Integer(wsNormal);
  Parameter1['PrintRatio'] := 100;
  Parameter1['PreviewRatio'] := 20;
  Parameter1['GraphicMode'] := 0;
  Parameter1['CLeft'] := 192;
  Parameter1['CTop'] := 114;

  // Mandelbrot2.MStep := 0.02200;
  // Mandelbrot2.Julia := False;
  // Mandelbrot2.MExecute;

  Caption := 'vZłB΂炭҂B';
  Mandelbrot1.MExecute;
end;

procedure TFrameForm.Mandelbrot1DblClick(Sender: TObject);
var
  MR: TRealRect;
  MP: TRealPoint;
  w, h: Extended;
begin
  if Fractal < 2 then // Mandelbrot set / Julia set
  begin
    MR := Mandelbrot1.MRect;
    w := MR.Right - MR.Left;
    h := MR.Top - MR.Bottom;
    MP := Mandelbrot1.C2M(DragPoint);
    MR.Left := MP.X - w / 2;
    MR.Top := MP.Y + h / 2;
    MR.Right := MR.Left + w;
    MR.Bottom := MR.Top - h;
    Mandelbrot1.MRect := MR;
    Caption := 'vZłB΂炭҂B';
    Mandelbrot1.MExecute;
  end;
end;

procedure TFrameForm.Mandelbrot2DblClick(Sender: TObject);
var
  MR: TRealRect;
  MP: TRealPoint;
  w, h: Extended;
begin
  MR := Mandelbrot1.MRect;
  w := MR.Right - MR.Left;
  h := MR.Top - MR.Bottom;
  MP := Mandelbrot2.C2M(DragPoint);
  MR.Left := MP.X - w / 2;
  MR.Top := MP.Y + h / 2;
  MR.Right := MR.Left + w;
  MR.Bottom := MR.Top - h;
  Mandelbrot1.MRect := MR;
  Caption := 'vZłB΂炭҂B';
  Mandelbrot1.MExecute;
end;

procedure TFrameForm.Mandelbrot1MouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  P: TPoint;
  Len: Integer;
  a: Extended;
begin
  if (Fractal > 1) and (Drawing = 1) then
  begin
    Mandelbrot1.Canvas.MoveTo(DragPoint.X, DragPoint.Y);
    Mandelbrot1.Canvas.LineTo(MovePoint.X, MovePoint.Y);
    Mandelbrot1.Canvas.Pen.Mode := pmCopy;

    Mandelbrot1.Canvas.Pen.Color := bC;
    Mandelbrot1.Canvas.Rectangle(DragPoint.X - pW, DragPoint.Y - pW,
                                 DragPoint.X + pW, DragPoint.Y + pW);
    Mandelbrot1.Canvas.Pen.Color := pC;
    Mandelbrot1.Canvas.Pen.Width := pW;

    if Fractal = 2 then
      Mandelbrot1.KochPolygon(DragPoint, MovePoint, kN, rC)
    else if Fractal = 3 then
      Mandelbrot1.CantorPolygon(DragPoint, MovePoint, cN, cW, cG, rC)
    else if Fractal = 4 then
      Mandelbrot1.GasketPolygon(DragPoint, MovePoint, rC)
    else if Fractal = 5 then
      Mandelbrot1.CarpetPolygon(DragPoint, MovePoint, rC)
    else if Fractal = 6 then
      Mandelbrot1.Hilbert(DragPoint, MovePoint, rC)
    else if Fractal = 7 then
      Mandelbrot1.Peano(DragPoint, MovePoint, rC)
    else if Fractal = 8 then
    begin
      if ColorForm.RadioButton1.Checked then // Type 1
        Mandelbrot1.Barnsley(DragPoint, MovePoint,
                             fern[1][1], // AffineData(0, 0, 0, 0.16, 0, 0, 0.01),
                             fern[1][2], // AffineData(0.85, 0.04, -0.04, 0.85, 0, 1.60, 0.85),
                             fern[1][3], // AffineData(0.20, -0.26, 0.23, 0.22, 0, 1.60, 0.07),
                             fern[1][4], // AffineData(-0.15, 0.28, 0.26, 0.24, 0, 0.44, 0.07),
                             ColorForm.g,
                             ColorForm.UpDown3.Position * 10000)
      else // Type 2
      begin
        ChangeDist(DragPoint, MovePoint, 2.0);
        Mandelbrot1.Barnsley(DragPoint, MovePoint,
                             fern[2][1], // AffineData(0, 0, 0, 0.25, 0, -0.4, 0.02),
                             fern[2][2], // AffineData(0.95, 0.005, -0.005, 0.93, -0.002, 0.5, 0.84),
                             fern[2][3], // AffineData(0.035, -0.2, 0.16, 0.04, -0.09, 0.02, 0.07),
                             fern[2][4], // AffineData(-0.04, 0.2, 0.16, 0.04, 0.083, 0.12, 0.07),
                             ColorForm.g,
                             ColorForm.UpDown3.Position * 10000);
      end;
    end
    else if Fractal = 9 then
    begin
      ChangeDist(DragPoint, MovePoint, 0.75);
      Mandelbrot1.Dragon(DragPoint, MovePoint, True, True, rC);
    end
    else if Fractal = 10 then
    begin
      ChangeDist(DragPoint, MovePoint, 0.5);
      Mandelbrot1.LevyC(DragPoint, MovePoint, 7, rC);
    end
    else if Fractal = 11 then
    begin
      Len := Round(Sqrt(SqrDist(DragPoint, MovePoint)) / 3);
      P.X := (DragPoint.X + MovePoint.X) div 2;
      P.Y := (DragPoint.Y + MovePoint.Y) div 2;
      a := LineAngle(DragPoint, MovePoint) + Pi / 2;
      Mandelbrot1.FractalTree(P, Len, a, ColorForm.la, ColorForm.ra, ColorForm.lR, ColorForm.rR, rC);
    end;

    Mandelbrot1.Canvas.Pen.Mode := pmNotXor;
    Drawing := 0;
  end;
end;

procedure TFrameForm.PopupMenu1Popup(Sender: TObject);
begin
  if Fractal < 2 then // Mandelbrot set / Julia set
  begin
    N13.Enabled := False;
    N14.Enabled := False;
    N18.Enabled := False;
    if CanN6 then N6.Enabled := True;
  end
  else
  begin
    N13.Enabled := True;
    N14.Enabled := True;
    N18.Enabled := True;
    N6.Enabled := False;
  end;

  N10.Checked := False;
  N28.Checked := False;
  N12.Checked := False;
  N19.Checked := False;
  N20.Checked := False;
  N16.Checked := False;
  N22.Checked := False;
  N23.Checked := False;
  N24.Checked := False;
  N25.Checked := False;
  N26.Checked := False;
  N27.Checked := False;

  case Fractal of
     0: N10.Checked := True; // Mandelbrot sett
     1: N28.Checked := True; // Julia set
     2: N12.Checked := True; // Koch curve
     3: N19.Checked := True; // Cantor set
     4: N20.Checked := True; // Sierpinski gasket
     5: N16.Checked := True; // Sierpinski carpet
     6: N22.Checked := True; // Hilbert curve
     7: N23.Checked := True; // Peano curve
     8: N24.Checked := True; // Barnsley fern
     9: N25.Checked := True; // Dragon curve
    10: N26.Checked := True; // Levy C curve
    11: N27.Checked := True; // Fractal tree
  end;

  if Drawing = -1 then
    N13.Checked := True
  else
    N13.Checked := False;
end;

procedure TFrameForm.N10Click(Sender: TObject);
begin
  if N10.Checked = False then
  begin
    ComboBox1.ItemIndex := 0;
    ComboBox1Change(Sender);
  end;
end;

procedure TFrameForm.N12Click(Sender: TObject);
begin
  if N12.Checked = False then
  begin
    ComboBox1.ItemIndex := 2;
    ComboBox1Change(Sender);
  end;
end;

procedure TFrameForm.N13Click(Sender: TObject);
begin
  if Drawing = -1 then
    Drawing := 0
  else
    Drawing := -1;
end;

procedure TFrameForm.N14Click(Sender: TObject);
begin
  Mandelbrot1.Canvas.FillRect(Rect(0, 0, Mandelbrot1.Width, Mandelbrot1.Height));
  Drawing := 0;
end;

procedure TFrameForm.N18Click(Sender: TObject);
begin
  Drawing := 0;
  if Fractal = 11 then
    pW := 1 //  Fractal tree ̐̑(1`5)
  else
    pW := 2; // ̑̐̑(1`5)
  cW := 10; // ̑(1`20) --- Cantor set
  cG := 10; // Mbv(1`20) --- Cantor set
  cN := 4; // np`̊p(0,3`32) --- Cantor set
  kN := 3; // np`̊p(0,3`32) --- Koch curve
  if (Fractal in [3, 6]) then
    rC := 5
  else if Fractal = 7 then
    rC := 3
  else if Fractal = 9 then
    rC := 14
  else if Fractal = 10 then
    rC := 11
  else if Fractal = 11 then
    rC := 12
  else
    rC := 4;
  if (Fractal in [8, 11]) then // Barnsley fern, Fractal tree
    pC := clGreen
  else if Fractal = 9 then // Dragon curve
    pC := clRed
  else if Fractal = 10 then // Levy C curve
    pC := clFuchsia
  else
    pC := clBlack;
  sC := clBlack; // Standard color
  bC := clWhite; // wiF
  Mandelbrot1.FractalInit(601, 601, pW, pC, bC);
  Mandelbrot1.Canvas.Pen.Mode := pmNotXor;
end;

procedure TFrameForm.N19Click(Sender: TObject);
begin
  if N19.Checked = False then
  begin
    ComboBox1.ItemIndex := 3;
    ComboBox1Change(Sender);
  end;
end;

procedure TFrameForm.N20Click(Sender: TObject);
begin
  if N20.Checked = False then
  begin
    ComboBox1.ItemIndex := 4;
    ComboBox1Change(Sender);
  end;
end;

procedure TFrameForm.N16Click(Sender: TObject);
begin
  if N16.Checked = False then
  begin
    ComboBox1.ItemIndex := 5;
    ComboBox1Change(Sender);
  end;
end;

procedure TFrameForm.Button9Click(Sender: TObject);
begin
  Open1Click(Sender);
end;

procedure TFrameForm.N22Click(Sender: TObject);
begin
  if N22.Checked = False then
  begin
    ComboBox1.ItemIndex := 6;
    ComboBox1Change(Sender);
  end;
end;

procedure TFrameForm.N23Click(Sender: TObject);
begin
  if N23.Checked = False then
  begin
    ComboBox1.ItemIndex := 7;
    ComboBox1Change(Sender);
  end;
end;

procedure TFrameForm.N24Click(Sender: TObject);
begin
  if N24.Checked = False then
  begin
    ComboBox1.ItemIndex := 8;
    ComboBox1Change(Sender);
  end;
end;

procedure TFrameForm.N25Click(Sender: TObject);
begin
  if N25.Checked = False then
  begin
    ComboBox1.ItemIndex := 9;
    ComboBox1Change(Sender);
  end;
end;

procedure TFrameForm.N26Click(Sender: TObject);
begin
  if N26.Checked = False then
  begin
    ComboBox1.ItemIndex := 10;
    ComboBox1Change(Sender);
  end;
end;

procedure TFrameForm.N27Click(Sender: TObject);
begin
  if N27.Checked = False then
  begin
    ComboBox1.ItemIndex := 11;
    ComboBox1Change(Sender);
  end;
end;

procedure TFrameForm.N28Click(Sender: TObject);
begin
  if N28.Checked = False then
  begin
    ComboBox1.ItemIndex := 1;
    ComboBox1Change(Sender);
  end;
end;

procedure TFrameForm.ComboBox1Change(Sender: TObject);
begin
  if ComboBox1.ItemIndex < 2 then
  begin
    Fractal := ComboBox1.ItemIndex;
    Mandelbrot1.Canvas.Pen.Mode := pmCopy;
    Button7Click(Sender);
  end
  else
  begin
    if Fractal < 2 then
      Mandelbrot1.FractalInit(601, 601, pW, pC, bC);
    Fractal := ComboBox1.ItemIndex;
    Drawing := 0;
    Mandelbrot1.Canvas.Pen.Mode := pmNotXor;
    pW := 2;
    rC := 4;
    pC := sC; // Standard color

    case Fractal of
      3: rC := 5; // Cantor set
      6: rC := 5; // Hilbert curve
      7: rC := 3; // Peano curve
      8: pC := clGreen; // Barnsley fern
      9: begin
           rC := 14; pC := clRed; // Dragon curve
         end;
      10: begin
            rC := 11; pC := clFuchsia; // Levy C curve
          end;
      11: begin
            pW := 1; rC := 12; pC := clGreen; // Fractal tree
          end;
    end;
  end;
end;

procedure TFrameForm.N5Click(Sender: TObject);
begin
  Button8Click(Sender);
end;

procedure TFrameForm.N6Click(Sender: TObject);
var
  Len, N: Integer;
  ExeName: String;
  FileName: String;
begin
  if (Fractal > 1) or (CanN6 = False) then
    Exit;

  Len := Length(Mandelbrot1.FrequencyM);
  ExeName := ExtractFilePath(Application.ExeName) + 'HuffGen.exe';

  if Fractal = 1 then // Julia set
  begin
    if Pos('Julia', ExtractFileName(OpenDialog1.Filename)) > 0 then
      FileName := ChangeFileExt(ExtractFileName(OpenDialog1.Filename), '')
    else
      FileName := 'Julia';
  end
  else // Mandelbrot set
  begin
    if Pos('Mandel', ExtractFileName(OpenDialog1.Filename)) > 0 then
      FileName := ChangeFileExt(ExtractFileName(OpenDialog1.Filename), '')
    else
      FileName := 'Mandel';
  end;

  FileName := HuffmanDir + '\' + FileName + '.gen';
  // FileName := NonExistName(FileName, False);

  {
  if Len > CMAX + 1 then Len := CMAX + 1;
  N := HuffmanFrequency(Mandelbrot1.FrequencyM,
                        Len,
                        FileName, //  FileName ̃t@C 쐬B
                        False);
  }
  N := GeneralFrequency(Mandelbrot1.FrequencyM,
                        Len,
                        FileName); //  FileName ̃t@C 쐬B
  if (N > 0) and (FileExists(FileName)) then
    ShellExecute(Handle, PChar('open'), PChar('"' + ExeName + '"'),
                 PChar('/G1 /I3 /D2 /B2 ' + '"' + FileName + '"'), Nil, SW_SHOW);
end;

initialization
  CF_JFIF := RegisterClipboardFormat('JFIF');
  TPicture.RegisterClipboardFormat(CF_JFIF, TJPEGImage);
  RegisterClass(TJPEGImage);

end.
